Index: main/cdr.c
===================================================================
--- main/cdr.c	(revision 105002)
+++ main/cdr.c	(working copy)
@@ -787,12 +787,8 @@
 	for (; cdr; cdr = cdr->next) {
 		if (!ast_test_flag(cdr, AST_CDR_FLAG_LOCKED)) {
 			check_post(cdr);
-			if (!app)
-				app = "";
-			ast_copy_string(cdr->lastapp, app, sizeof(cdr->lastapp));
-			if (!data)
-				data = "";
-			ast_copy_string(cdr->lastdata, data, sizeof(cdr->lastdata));
+			ast_copy_string(cdr->lastapp, S_OR(app, ""), sizeof(cdr->lastapp));
+			ast_copy_string(cdr->lastdata, S_OR(data, ""), sizeof(cdr->lastdata));
 		}
 	}
 }
Index: main/pbx.c
===================================================================
--- main/pbx.c	(revision 105002)
+++ main/pbx.c	(working copy)
@@ -516,7 +516,7 @@
 	const char *saved_c_appl;
 	const char *saved_c_data;
 
-	if (c->cdr &&  !ast_check_hangup(c))
+	if (c->cdr && !ast_check_hangup(c))
 		ast_cdr_setapp(c->cdr, app->name, data);
 
 	/* save channel values */
@@ -529,7 +529,7 @@
 	if (app->module) {
 		/* XXX LOCAL_USER_ADD(app->module) */
 	}
-	res = app->execute(c, data);
+	res = app->execute(c, S_OR(data, ""));
 	if (app->module) {
 		/* XXX LOCAL_USER_REMOVE(app->module) */
 	}
